/* -----------JScript macros for Code-Genie V2.5 -------------
* In order To enable the macro feature you must install the
* ScriptContol from Microsoft. Some places where you can Find
* it:
* www.code-genie.com/sc.exe
* www.activex.com
* www.microsoft.com
*
*/
//------------ Sample macros ---------------

// Greetings
function jsGreetings()
{
	Doc.MsgBox("Hello World");
}

// Append text to the end of doc
function jsAppend()
{
	Doc.SSE=cgDocEnd; // or =Doc.Size
	Doc.SelText="Text to append goes here";
}

// Remove the selected text
function jsDelSelection()
{
	Doc.SelText="";
}

// Select the word the cursor is currently over
function jsSelWord()
{
	Doc.SS=Doc.AuxMove(Doc.SE,cgWordLeft);
	Doc.SE=Doc.AuxMove(Doc.SE,cgWordRight);
}

// Remove the 3rd row
function jsRemove3rdRow()
{
	// numbering starts from 0
	if(Doc.LineCount()<2) return;
	Doc.SS=Doc.LineToPos(2);
	Doc.SE=Doc.AuxMove(Doc.SS,cgLineEnd);
	if(Doc.GetChar(Doc.SE) == "\n")
		Doc.SE++;
	Doc.SelText="";
}

// prefix each line with "row No:"
// where No is the number of the given row
function jsPrefixLines()
{
	for(var i=0;i<Doc.LineCount()-1;i++){
		Doc.SSE=Doc.LineToPos(i);
		Doc.SelText="row "+i+": ";
	}
}

// Remove HTML-tags from the doc
function jsRemoveHTMLTags()
{
	Doc.SSE=Doc.SE; //Remove the selection if any, so Replace applies to the whole doc
	Doc.Replace("<.*>","",cgFindRegExp);
}

// Multiplication-table
// from 1x1 to 9x9
function jsMulTable()
{
	Doc.SSE=Doc.SE; // remove the selection if any
	for(var i=1;i<=9;i++)
		for(var j=1;j<=9;j++)
			Doc.SelText=i+"x"+j+"= "+(i*j)+"\n";
}

// Moves To the Next function defintion
function jsCPPNextFunctionDef()
{
	nLine=Doc.PosToLine(Doc.SSE);
	if(nLine<Doc.LineCount()-2){
		Doc.SSE=Doc.LineToPos(nLine+2);
		a=Doc.Find("^\\{",cgFindRegExp);
		if(a!=-1){
			a=Doc.PosToLine(a)-1;
			Doc.SSE=Doc.LineToPos(a);
		}
	}
}

// Moves To the previous function definition
function jsCPPPrevFunctionDef()
{
	a=Doc.Find("^\\{",cgFindUp|cgFindRegExp);
	if(a!=-1){
		nLine=Doc.PosToLine(a)
		if(nLine>0) nLine--;
		Doc.SSE=Doc.LineToPos(nLine)
	}
}

// --------- User Defined Macros ------------


// evaluate the selected text
function jsCalculator()
{
	var s=Doc.SelText;
	s=s.replace("asin(","Math.asin(");
	s=s.replace("sin(","Math.sin(");
	s=s.replace("acos(","Math.acos(");
	s=s.replace("cos(","Math.cos(");
	s=s.replace("atan(","Math.atan(");
	s=s.replace("tan(","Math.tan(");
	s=s.replace("exp(","Math.exp(");
	s=s.replace("log(","Math.log(");
	s=s.replace("pow(","Math.pow(");
	s=s.replace("sqrt(","Math.sqrt(");
	s=s.replace("PI","Math.PI");
	s=s.replace("E","Math.E");
	var a=eval(s);
	Doc.MsgBox(a);
}

// add the numbers of each row
function addNumbers()
{
	var sum=0;
	for(var i=0;i<Doc.LineCount();i++){
		Doc.SS=Doc.LineToPos(i);
		Doc.SE=Doc.AuxMove(Doc.SS,cgLineEnd);
		var v=parseFloat(Doc.SelText);
		if(isNaN(v) ){
			Doc.MsgBox("Error: Not a number!");
			return;
		}
		sum+=v;
	}
	Doc.MsgBox("Sub: "+sum);
}

// Description
function HTMLize()
{
	Doc.Replace("<","&lt;");
	Doc.Replace(">","&gt;");
}
